import { DOWNLOAD_PATH } from "$env/static/private";
import { redirect } from "@sveltejs/kit";
import youtubedl from "youtube-dl-exec";

export const actions = {
  download: async ({ request, cookies }) => {
    const data = await request.formData();

    const obj = {};
    for (const element of data) {
      obj[element[0]] = element[1];
    }

    const { format, source, link } = obj;

    if (!(format && source && link)) {
      throw redirect(307, "/");
    }

    console.info(`Asked ${source} download of ${link}`);

    switch (source) {
      case "youtube":
        const output = await youtubedl(link, {
          output: `${DOWNLOAD_PATH}/%(artist)s-%(title)s.%(ext)s`,
          embedThumbnail: true,
          audioFormat: format
        });

        console.log(output);
        console.info(`Downloaded ${link} to ${output}`);

        break;
      case "spotify":
        break;
      default:
        console.error("ops");
    }

    return { success: true };
  },
};
